Index: code/branches/hudelements/src/modules/overlays/hud/HUDNavigation.cc
===================================================================
--- code/branches/hudelements/src/modules/overlays/hud/HUDNavigation.cc	(revision 6896)
+++ code/branches/hudelements/src/modules/overlays/hud/HUDNavigation.cc	(revision 6897)
@@ -46,4 +46,5 @@
 #include "worldentities/pawns/Pawn.h"
 #include "worldentities/WorldEntity.h"
+#include "interfaces/RadarViewable.h"
 
 namespace orxonox
@@ -55,13 +56,16 @@
 {
     RegisterObject(HUDNavigation);
-    
-     
-     const std::set<RadarViewable*>& respawnObjectSet_ = this->getOwner()->getScene()->getRadar()->getRadarObjects();
-     std::set<RadarViewable*>::const_iterator respawnObjectSetIt_;
-     
-     if(!respawnObjectSet_.empty()){
-     for(respawnObjectSetIt_ = respawnObjectSet_.begin(); respawnObjectSetIt_ != respawnObjectSet_.end();
-	 ++respawnObjectSetIt_){ addObject(*respawnObjectSetIt_);}
-     }
+
+    setFont("Monofur");
+    setTextSize(0.05f);
+    setNavMarkerSize(0.05f);
+
+    respawnObjectSet_ = this->getOwner()->getScene()->getRadar()->getRadarObjects();  
+
+    for (respawnObjectSetIt_ = respawnObjectSet_.begin(); respawnObjectSetIt_ != respawnObjectSet_.end();
+            ++respawnObjectSetIt_)
+    {
+        if (!(*respawnObjectSetIt_)->isHumanShip_)  addObject(*respawnObjectSetIt_);
+    }
     
 //         // create nav text
@@ -74,47 +78,37 @@
 //         navMarker_->setMaterialName("Orxonox/NavArrows");
 
-    /*
-            // create aim marker
-            aimMarker_ = static_cast<Ogre::PanelOverlayElement*>(Ogre::OverlayManager::getSingleton()
-                .createOverlayElement("Panel", "HUDNavigation_aimMarker_" + getUniqueNumberString()));
-            aimMarker_->setMaterialName("Orxonox/NavCrosshair");
-            this->wasOutOfView_ = true; // Ensure the material is changed right the first time..
-
-
-    */
-    /*
-            background_->addChild(navMarker_);*/
+        /*
+                // create aim marker
+                aimMarker_ = static_cast<Ogre::PanelOverlayElement*>(Ogre::OverlayManager::getSingleton()
+                    .createOverlayElement("Panel", "HUDNavigation_aimMarker_" + getUniqueNumberString()));
+                aimMarker_->setMaterialName("Orxonox/NavCrosshair");
+                this->wasOutOfView_ = true; // Ensure the material is changed right the first time..
+
+
+        */
+        /*
+                background_->addChild(navMarker_);*/
 //        background_->addChild(aimMarker_);
 //         background_->addChild(navText_);
 
-    // hide at first
+        // hide at first
 //         this->setVisible(false);
 
 
-    setFont("Monofur");
-    setTextSize(0.05f);
-    setNavMarkerSize(0.05f);
+
 //         setAimMarkerSize(0.04f);
-}
-
-HUDNavigation::~HUDNavigation()
-{
+    
+}
+
+HUDNavigation::~HUDNavigation() {
 
     if (this->isInitialized())
     {
-        if (!activeObjectList_.empty())
-        {
-            for (tempRadarViewable = activeObjectList_.begin(); tempRadarViewable!=activeObjectList_.end(); ++tempRadarViewable)
-            {
-                Ogre::OverlayManager::getSingleton().destroyOverlayElement(tempRadarViewable->second.first);
-                Ogre::OverlayManager::getSingleton().destroyOverlayElement(tempRadarViewable->second.second);
-//            Ogre::OverlayManager::getSingleton().destroyOverlayElement(this->aimMarker_);
-            }
-        }
-    }
-}
-
-void HUDNavigation::XMLPort(Element& xmlElement, XMLPort::Mode mode)
-{
+        activeObjectList_.clear();
+        respawnObjectSet_.clear();
+    }
+}
+
+void HUDNavigation::XMLPort(Element& xmlElement, XMLPort::Mode mode) {
     SUPER(HUDNavigation, XMLPort, xmlElement, mode);
 
@@ -304,8 +298,8 @@
                 tempRadarViewable->second.second->setTop((-pos.y + 1.0f + tempRadarViewable->second.first->getHeight()) * 0.5f);
             }
-	          
-    tempRadarViewable->second.first->show();
-    tempRadarViewable->second.second->show();
-    }
+
+            tempRadarViewable->second.first->show();
+            tempRadarViewable->second.second->show();
+        }
 
     }
@@ -398,4 +392,12 @@
 }
 
+// void HUDRadar::changedOwner() {
+//     SUPER(HUDRadar, changedOwner);
+//
+//     this->owner_ = orxonox_cast<Pawn*>(this->getOwner());
+//     assert(this->radarObjects_.size()==0);
+//     this->gatherObjects();
+// }
+
 // 	void updateActiveObjectList(map activeObjectList_){}
 //
Index: code/branches/hudelements/src/modules/overlays/hud/HUDNavigation.h
===================================================================
--- code/branches/hudelements/src/modules/overlays/hud/HUDNavigation.h	(revision 6896)
+++ code/branches/hudelements/src/modules/overlays/hud/HUDNavigation.h	(revision 6897)
@@ -33,4 +33,5 @@
 #include <map>
 #include "overlays/OverlaysPrereqs.h"
+#include "interfaces/RadarViewable.h"
 
 #include "interfaces/RadarListener.h"
@@ -57,4 +58,5 @@
     inline float getRadarSensitivity() const {return 1.0f;}
     inline void radarTick(float dt) {}
+//     virtual void changedOwner();
 
 
@@ -111,4 +113,8 @@
     activeObjectListType activeObjectList_;
     activeObjectListType::iterator tempRadarViewable;
+    
+    typedef std::set<RadarViewable*> respawnObjectSetType;
+    respawnObjectSetType respawnObjectSet_;
+    respawnObjectSetType::iterator respawnObjectSetIt_;
 
     std::string fontName_;
Index: code/branches/hudelements/src/modules/overlays/hud/HUDRadar.cc
===================================================================
--- code/branches/hudelements/src/modules/overlays/hud/HUDRadar.cc	(revision 6896)
+++ code/branches/hudelements/src/modules/overlays/hud/HUDRadar.cc	(revision 6897)
@@ -188,9 +188,9 @@
     void HUDRadar::changedOwner()
     {
-        SUPER(HUDRadar, changedOwner);
+    SUPER(HUDRadar, changedOwner);
 
-        this->owner_ = orxonox_cast<Pawn*>(this->getOwner());
-        assert(this->radarObjects_.size()==0);
-        this->gatherObjects();
-    }
+    this->owner_ = orxonox_cast<Pawn*>(this->getOwner());
+    assert(this->radarObjects_.size()==0);
+    this->gatherObjects();
 }
+}