Index: /code/branches/hudelements/src/modules/overlays/hud/HUDNavigation.cc
===================================================================
--- /code/branches/hudelements/src/modules/overlays/hud/HUDNavigation.cc	(revision 6897)
+++ /code/branches/hudelements/src/modules/overlays/hud/HUDNavigation.cc	(revision 6898)
@@ -61,11 +61,5 @@
     setNavMarkerSize(0.05f);
 
-    respawnObjectSet_ = this->getOwner()->getScene()->getRadar()->getRadarObjects();  
-
-    for (respawnObjectSetIt_ = respawnObjectSet_.begin(); respawnObjectSetIt_ != respawnObjectSet_.end();
-            ++respawnObjectSetIt_)
-    {
-        if (!(*respawnObjectSetIt_)->isHumanShip_)  addObject(*respawnObjectSetIt_);
-    }
+
     
 //         // create nav text
@@ -182,5 +176,5 @@
         for (tempRadarViewable = activeObjectList_.begin(); tempRadarViewable!=activeObjectList_.end(); ++tempRadarViewable)
         {
-            COUT(0) << "check 174" << std::endl;
+
 
             //get Distance to HumanController and save it in the TextAreaOverlayElement.
@@ -189,5 +183,5 @@
             float textLength = multi_cast<std::string>(dist).size() * tempRadarViewable->second.second->getCharHeight() * 0.3f;
 
-            COUT(0) << "check 181" << std::endl;
+
 
             orxonox::Camera* cam = CameraManager::getInstance().getActiveCamera();
@@ -198,5 +192,5 @@
             Vector3 pos = transform * tempRadarViewable->first->getRVWorldPosition();
 
-            COUT(0) << "check 190" << std::endl;
+
 
             bool outOfView;
@@ -224,5 +218,5 @@
                 }
 
-                COUT(0) << "check 174" << std::endl;
+
 
                 if (pos.x < pos.y)
@@ -272,5 +266,5 @@
             else
             {
-                COUT(0) << "check 264" << std::endl;
+
 
                 // object is in view
@@ -299,6 +293,6 @@
             }
 
-            tempRadarViewable->second.first->show();
-            tempRadarViewable->second.second->show();
+	     tempRadarViewable->second.first->show();
+	     tempRadarViewable->second.second->show();
         }
 
@@ -308,12 +302,12 @@
 
 
-float HUDNavigation::getDist2Focus() const {
-
-    Radar* radar = this->getOwner()->getScene()->getRadar();
-    if (radar->getFocus() && HumanController::getLocalControllerEntityAsPawn())
-        return (radar->getFocus()->getRVWorldPosition() - HumanController::getLocalControllerEntityAsPawn()->getWorldPosition()).length();
-    else
-        return 0;
-}
+// float HUDNavigation::getDist2Focus() const {
+// 
+//     Radar* radar = this->getOwner()->getScene()->getRadar();
+//     if (radar->getFocus() && HumanController::getLocalControllerEntityAsPawn())
+//         return (radar->getFocus()->getRVWorldPosition() - HumanController::getLocalControllerEntityAsPawn()->getWorldPosition()).length();
+//     else
+//         return 0;
+// }
 
 /**
@@ -361,5 +355,6 @@
     Ogre::TextAreaOverlayElement* text = static_cast<Ogre::TextAreaOverlayElement*>(Ogre::OverlayManager::getSingleton()
                                          .createOverlayElement("TextArea", "HUDNavigation_navText_" + getUniqueNumberString()));
-
+		
+   
     float xScale = this->getActualSize().x;
     float yScale = this->getActualSize().y;
@@ -375,5 +370,5 @@
 // 	background_->addChild(activeObjectList_[object].first);
 // 	background_->addChild(activeObjectList_[object].second);
-    COUT(0) << "check 357" << std::endl;
+
 }
 
@@ -392,11 +387,19 @@
 }
 
-// void HUDRadar::changedOwner() {
-//     SUPER(HUDRadar, changedOwner);
-//
-//     this->owner_ = orxonox_cast<Pawn*>(this->getOwner());
-//     assert(this->radarObjects_.size()==0);
-//     this->gatherObjects();
-// }
+void HUDNavigation::changedOwner() {
+     
+
+ 
+    respawnObjectSet_ = this->getOwner()->getScene()->getRadar()->getRadarObjects();
+    respawnObjectSetType::iterator respawnObjectSetIt_;
+    for (respawnObjectSetIt_ = respawnObjectSet_.begin(); respawnObjectSetIt_ != respawnObjectSet_.end();
+            ++respawnObjectSetIt_)
+    {
+        if (!(*respawnObjectSetIt_)->isHumanShip_)  HUDNavigation::addObject(*respawnObjectSetIt_);
+    }
+
+}
+
+
 
 // 	void updateActiveObjectList(map activeObjectList_){}
Index: /code/branches/hudelements/src/modules/overlays/hud/HUDNavigation.h
===================================================================
--- /code/branches/hudelements/src/modules/overlays/hud/HUDNavigation.h	(revision 6897)
+++ /code/branches/hudelements/src/modules/overlays/hud/HUDNavigation.h	(revision 6898)
@@ -58,5 +58,5 @@
     inline float getRadarSensitivity() const {return 1.0f;}
     inline void radarTick(float dt) {}
-//     virtual void changedOwner();
+    virtual void changedOwner();
 
 
@@ -95,5 +95,5 @@
     void updateMarker();
     void updateFocus();
-    float getDist2Focus() const;
+//     float getDist2Focus() const;
     void getSingleton();
 
@@ -113,8 +113,9 @@
     activeObjectListType activeObjectList_;
     activeObjectListType::iterator tempRadarViewable;
-    
+        
     typedef std::set<RadarViewable*> respawnObjectSetType;
     respawnObjectSetType respawnObjectSet_;
-    respawnObjectSetType::iterator respawnObjectSetIt_;
+    
+
 
     std::string fontName_;