Index: code/branches/rocket/src/modules/weapons/RocketController.cc
===================================================================
--- code/branches/rocket/src/modules/weapons/RocketController.cc	(revision 6899)
+++ code/branches/rocket/src/modules/weapons/RocketController.cc	(revision 6900)
@@ -42,9 +42,10 @@
     RocketController::RocketController(BaseObject* creator) : Controller(creator)
     {
+		RegisterObject(RocketController);
 		COUT(0)<< "RocketController constructed\n";
 
-        RegisterObject(RocketController);
+        
 		this->rocket = new SimpleRocket(this);
-		this->rocket->setController(dynamic_cast<RocketController*>(this));
+		this->rocket->setController(this);
 		this->setControllableEntity(dynamic_cast<ControllableEntity*> (rocket));
 		this->haha=0;
@@ -63,15 +64,11 @@
 
         SimpleRocket *rocket = static_cast<SimpleRocket*>(this->getControllableEntity());
-		rocket->setAcceleration(rocket->getAcceleration()*2);
-		if (haha < 100) rocket->rotateYaw(10);
-		else {
-		if (rand() > 0.5) rocket->rotateRoll(5); 
-		else rocket->rotatePitch(5);
-		}
-
-    }
+		rocket->moveRightLeft(5);
+	
+	}
 
 
 	RocketController::~RocketController() {
+
 		
 		COUT(0)<< "RocketController destroyed\n";
Index: code/branches/rocket/src/modules/weapons/projectiles/SimpleRocket.cc
===================================================================
--- code/branches/rocket/src/modules/weapons/projectiles/SimpleRocket.cc	(revision 6899)
+++ code/branches/rocket/src/modules/weapons/projectiles/SimpleRocket.cc	(revision 6900)
@@ -62,6 +62,6 @@
 
 
-        //if (GameMode::isMaster())
-        //{
+        if (GameMode::isMaster())
+       {
            this->setCollisionType(WorldEntity::Kinematic);
             this->setVelocity(0,0,100);
@@ -87,7 +87,11 @@
 
             this->destroyTimer_.setTimer(this->lifetime_, false, createExecutor(createFunctor(&SimpleRocket::destroyObject, this)));
-       // }
-
-    }
+        }
+
+    }
+	void SimpleRocket::tick(float dt)
+    {
+        SUPER(SimpleRocket, tick, dt);
+	}
 
     /**s
Index: code/branches/rocket/src/modules/weapons/projectiles/SimpleRocket.h
===================================================================
--- code/branches/rocket/src/modules/weapons/projectiles/SimpleRocket.h	(revision 6899)
+++ code/branches/rocket/src/modules/weapons/projectiles/SimpleRocket.h	(revision 6900)
@@ -51,5 +51,5 @@
             SimpleRocket(BaseObject* creator);
             virtual ~SimpleRocket();
-
+			virtual void tick(float dt);
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a SimpleRocket through XML.
 
Index: code/branches/rocket/src/modules/weapons/weaponmodes/SimpleRocketFire.cc
===================================================================
--- code/branches/rocket/src/modules/weapons/weaponmodes/SimpleRocketFire.cc	(revision 6899)
+++ code/branches/rocket/src/modules/weapons/weaponmodes/SimpleRocketFire.cc	(revision 6900)
@@ -61,5 +61,4 @@
     void SimpleRocketFire::fire()
     {
-        //SimpleRocket* rocket = new SimpleRocket(this);
 		RocketController* con = new RocketController(this);
 		SimpleRocket* rocket = con->getRocket();
@@ -69,21 +68,5 @@
         rocket->setPosition(pos);
 		rocket->setVelocity(this->getMuzzleDirection()*this->speed_);
-		//Ogre::Vector3 vec = this->getMuzzlePosition();
-		//vec.normalise();
-		//rocket->setAcceleration(100*vec);
 		rocket->setOwner(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn());
-		//con->getRocket()->setPosition(this->getMuzzlePosition());
-	//con->setControllableEntity(dynamic_cast<rocket*>(ControllableEntity));
-	//con->getControllableEntity()->setPosition(this->getMuzzlePosition());
-
-        /* this->computeMuzzleParameters(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn()->getAimPosition());
-        rocket->setOrientation(this->getMuzzleOrientation());
-        rocket->setPosition(this->getMuzzlePosition());
-		rocket->scale(10);
-        rocket->setVelocity(this->getMuzzleDirection() * this->speed_);
-        rocket->setOwner(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn());
-        rocket->setDamage(this->getDamage()); 
-        rocket->scale(2);
-		*/
     }
 }