Index: /code/branches/lod/data/levels/empty_level.oxw
===================================================================
--- /code/branches/lod/data/levels/empty_level.oxw	(revision 6908)
+++ /code/branches/lod/data/levels/empty_level.oxw	(revision 6909)
@@ -2,4 +2,5 @@
   include("stats.oxo")
   include("hudtemplates3.oxo")
+  include("templates/lodinformation.oxt")
 ?>
 
@@ -13,4 +14,8 @@
  description  = "Just a few tests"
 >
+  <templates>
+    <Template link=lodtemplate_default />
+  </templates>
+
   <Scene
     ambientlight = "0.8, 0.8, 0.8"
Index: /code/branches/lod/data/levels/gametype_asteroids.oxw
===================================================================
--- /code/branches/lod/data/levels/gametype_asteroids.oxw	(revision 6908)
+++ /code/branches/lod/data/levels/gametype_asteroids.oxw	(revision 6909)
@@ -3,4 +3,5 @@
   include("stats.oxo")
   include("templates/spaceship_assff.oxt")
+  include("templates/lodinformation.oxt")
 ?>
 
@@ -10,4 +11,8 @@
  gametype     =  Asteroids
 >
+  <templates>
+    <Template link=lodtemplate_default />
+  </templates>
+
 <Scene
  ambientlight = "0.5, 0.5, 0.5"
Index: /code/branches/lod/data/levels/teambasematchlevel.oxw
===================================================================
--- /code/branches/lod/data/levels/teambasematchlevel.oxw	(revision 6908)
+++ /code/branches/lod/data/levels/teambasematchlevel.oxw	(revision 6909)
@@ -5,4 +5,5 @@
   include("templates/spaceship_assff.oxt")
   include("templates/spaceship_pirate.oxt")
+  include("templates/lodinformation.oxt")
 ?>
 
@@ -12,4 +13,8 @@
  gametype     = TeamBaseMatch
 >
+  <templates>
+    <Template link=lodtemplate_default />
+  </templates>
+
   <Scene
    ambientlight = "0.5, 0.5, 0.5"
Index: /code/branches/lod/data/levels/teamdeathmatch.oxw
===================================================================
--- /code/branches/lod/data/levels/teamdeathmatch.oxw	(revision 6908)
+++ /code/branches/lod/data/levels/teamdeathmatch.oxw	(revision 6909)
@@ -5,4 +5,5 @@
   include("templates/spaceship_H2.oxt")
   include("templates/spaceship_pirate.oxt")
+  include("templates/lodinformation.oxt")
 ?>
 
@@ -12,4 +13,8 @@
  gametype     = TeamDeathmatch
 >
+  <templates>
+    <Template link=lodtemplate_default />
+  </templates>
+
   <Scene
    ambientlight = "0.7, 0.6, 0.6"
Index: /code/branches/lod/data/levels/templates/lodinformation.oxt
===================================================================
--- /code/branches/lod/data/levels/templates/lodinformation.oxt	(revision 6908)
+++ /code/branches/lod/data/levels/templates/lodinformation.oxt	(revision 6909)
@@ -2,5 +2,6 @@
   <Level>
 	<lodinformation>
-	  <MeshLodInformation mesh=Carrier.mesh lodQuality=2.4 />
+	  <MeshLodInformation mesh=Carrier.mesh lodQuality=1.8 />
+	  <MeshLodInformation mesh=assff.mesh lodQuality=3 />
 	</lodinformation>
   </Level>
Index: /code/branches/lod/src/orxonox/Level.cc
===================================================================
--- /code/branches/lod/src/orxonox/Level.cc	(revision 6908)
+++ /code/branches/lod/src/orxonox/Level.cc	(revision 6909)
@@ -49,4 +49,5 @@
         RegisterObject(Level);
 
+        
         this->registerVariables();
         this->xmlfilename_ = this->getFilename();
Index: /code/branches/lod/src/orxonox/graphics/Model.cc
===================================================================
--- /code/branches/lod/src/orxonox/graphics/Model.cc	(revision 6908)
+++ /code/branches/lod/src/orxonox/graphics/Model.cc	(revision 6909)
@@ -49,4 +49,6 @@
 
         this->registerVariables();
+        //LoD
+        this->lodLevel_=5;
     }
 
Index: /code/branches/lod/src/orxonox/graphics/Model.h
===================================================================
--- /code/branches/lod/src/orxonox/graphics/Model.h	(revision 6908)
+++ /code/branches/lod/src/orxonox/graphics/Model.h	(revision 6909)
@@ -67,7 +67,7 @@
             
             //LoD
-            inline void setLodLevel(unsigned short lodLevel)
+            inline void setLodLevel(float lodLevel)
                 { this->lodLevel_ =  lodLevel; }
-            inline unsigned short getLodLevel() const
+            inline float getLodLevel() const
                 { return this->lodLevel_; }
             float Model::getBiggestScale(Vector3 scale3d);
@@ -78,5 +78,5 @@
             
             //LoD
-            unsigned short lodLevel_;
+            float lodLevel_;
     };
 }